
%undefine _missing_build_ids_terminate_build

%global mver 3.0

Name: guile30
Version: 3.0.7
Release:    1%{?dist}
Summary: A GNU implementation of Scheme for application extensibility
License: LGPLv3+ and MIT and Public Domain and GPL+ and GPLv3+
Source0: https://ftp.gnu.org/gnu/guile/guile-%{version}.tar.gz
URL: https://www.gnu.org/software/guile/

BuildRequires: libtool libtool-ltdl-devel pkgconfig(gmp) pkgconfig(readline)
BuildRequires: gettext-devel libunistring-devel pkgconfig(libffi) pkgconfig(bdw-gc)
BuildRequires: make gcc
BuildRequires: autoconf 
BuildRequires: pkgconfig
Requires: coreutils
Requires(post): info
Requires(preun): info

Provides: bundled(gnulib)

Patch0: guile-3.0.7-headers.patch

Patch1: guile-3.0.7-disable-oom-test.patch

Patch2: guile-3.0.7-chroot.patch

Patch3: guile-3.0.7-configure.patch

Patch4: guile-3.0.7-disable-stackoverflow-test.patch

Patch5: guile30-configure-tz-c99.patch

%description
GUILE (GNU's Ubiquitous Intelligent Language for Extension) is a library
implementation of the Scheme programming language, written in C.  GUILE
provides a machine-independent execution platform that can be linked in
as a library during the building of extensible programs.

Install the guile package if you'd like to add extensibility to programs
that you are developing.

%package devel
Summary: Libraries and header files for the GUILE extensibility library
Requires: guile30 = %{version}-%{release} pkgconfig(gmp) pkgconfig(bdw-gc)
Requires: pkgconfig

%description devel
The guile-devel package includes the libraries, header files, etc.,
that you'll need to develop applications that are linked with the
GUILE extensibility library.

You need to install the guile-devel package if you want to develop
applications that will be linked to GUILE.  You'll also need to
install the guile package.

%prep
%autosetup -p1 -n guile-%version

%build
autoreconf -iv
%configure --disable-static --disable-error-on-warning --program-suffix=%{mver}

%make_build

%install
%make_install
mkdir -p %{buildroot}%{_datadir}/guile/site/%{mver}

rm -f %{buildroot}%{_libdir}/libguile*.la
rm -f %{buildroot}%{_infodir}/dir

for i in $(seq 1 11); do
  mv %{buildroot}%{_infodir}/guile{,-%{mver}}.info-$i
  sed -i -e 's/guile\.info/guile-%{mver}.info/' %{buildroot}%{_infodir}/guile-%{mver}.info-$i
  sed -i -e 's/\* Guile Reference: (guile)/* Guile %{mver} Reference: (guile-%{mver})/' %{buildroot}%{_infodir}/guile-%{mver}.info-$i
done
mv %{buildroot}%{_infodir}/guile{,-%{mver}}.info
sed -i -e 's/guile\.info/guile-%{mver}.info/' %{buildroot}%{_infodir}/guile-%{mver}.info
sed -i -e 's/\* Guile Reference: (guile)/* Guile %{mver} Reference: (guile-%{mver})/' %{buildroot}%{_infodir}/guile-%{mver}.info
mv %{buildroot}%{_infodir}/r5rs{,-%{mver}}.info
mv %{buildroot}%{_datadir}/aclocal/guile{,-%{mver}}.m4

rm -f %{buildroot}%{_libdir}/libguile*gdb.scm

for i in %{buildroot}%{_infodir}/goops.info; do
    iconv -f iso8859-1 -t utf-8 < $i > $i.utf8 && mv -f ${i}{.utf8,}
done

touch %{buildroot}%{_datadir}/guile/site/%{mver}/slibcat

find %{buildroot}%{_datadir} -name '*.scm' -exec touch -r "%{_specdir}/guile3.spec" '{}' \;
find %{buildroot}%{_libdir} -name '*.go' -exec touch -r "%{_specdir}/guile3.spec" '{}' \;

rm %{buildroot}%{_libdir}/guile/%{mver}/extensions/guile-readline.la

%check
make %{?_smp_mflags} check || true

%post
install-info %{_infodir}/guile-3.0.info.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-1.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-2.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-3.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-4.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-5.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-6.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-7.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-8.gz %{_infodir}/dir
install-info %{_infodir}/guile-3.0.info-9.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-10.gz %{_infodir}/dir 
install-info %{_infodir}/guile-3.0.info-11.gz %{_infodir}/dir 
install-info %{_infodir}/r5rs-3.0.info.gz %{_infodir}/dir 

%preun
install-info --delete %{_infodir}/guile-3.0.info.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-1.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-2.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-3.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-4.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-5.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-6.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-7.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-8.gz %{_infodir}/dir
install-info --delete %{_infodir}/guile-3.0.info-9.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-10.gz %{_infodir}/dir 
install-info --delete %{_infodir}/guile-3.0.info-11.gz %{_infodir}/dir 
install-info --delete %{_infodir}/r5rs-3.0.info.gz %{_infodir}/dir 

%triggerin -- slib >= 3b4-1
rm -f %{_datadir}/guile/site/%{mver}/slibcat
export SCHEME_LIBRARY_PATH=%{_datadir}/slib/

%{_bindir}/guile%{mver} --fresh-auto-compile --no-auto-compile -c \
    "(use-modules (ice-9 slib)) (require 'new-catalog)" &> /dev/null || \
    rm -f %{_datadir}/guile/site/%{mver}/slibcat
:


%triggerun -- slib >= 3b4-1
if [ "$2" = 0 ]; then
    rm -f %{_datadir}/guile/site/%{mver}/slibcat
fi

%files
%license COPYING COPYING.LESSER LICENSE
%doc AUTHORS HACKING README THANKS
%{_bindir}/guild%{mver}
%{_bindir}/guile%{mver}
%{_bindir}/guile-tools%{mver}
%{_libdir}/libguile-%{mver}.so.1*
%{_libdir}/guile
%dir %{_datadir}/guile
%dir %{_datadir}/guile/site
%dir %{_datadir}/guile/%{mver}
%dir %{_datadir}/guile/site/%{mver}
%{_datadir}/guile/%{mver}/ice-9
%{_datadir}/guile/%{mver}/language
%{_datadir}/guile/%{mver}/oop
%{_datadir}/guile/%{mver}/rnrs
%{_datadir}/guile/%{mver}/scripts
%{_datadir}/guile/%{mver}/srfi
%{_datadir}/guile/%{mver}/sxml
%{_datadir}/guile/%{mver}/system
%{_datadir}/guile/%{mver}/texinfo
%{_datadir}/guile/%{mver}/web
%{_datadir}/guile/%{mver}/guile-procedures.txt
%{_datadir}/guile/%{mver}/*.scm
%{_datadir}/guile/%{mver}/scheme/*.scm
%dir %{_datadir}/guile/%{mver}/scheme
%ghost %{_datadir}/guile/site/%{mver}/slibcat
%{_infodir}/*
%{_mandir}/man1/guile%{?mver}*

%files devel
%{_bindir}/guile-config%{?mver}
%{_bindir}/guile-snarf%{?mver}
%{_datadir}/aclocal/*
%{_libdir}/libguile-%{mver}.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/guile

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.7-1
- initial build
